"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getOptions;

var _schemaUtils = _interopRequireDefault(require("schema-utils"));

var _options = _interopRequireDefault(require("./options.json"));

var _getCLIEngine = _interopRequireDefault(require("./getCLIEngine"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getOptions(pluginOptions) {
  const options = {
    files: '.',
    ...pluginOptions
  };
  (0, _schemaUtils.default)(_options.default, options, {
    name: 'ESLint Webpack Plugin',
    baseDataPath: 'options'
  });
  const {
    CLIEngine
  } = (0, _getCLIEngine.default)(options, false);
  options.formatter = getFormatter(CLIEngine, options.formatter);

  if (options.outputReport && options.outputReport.formatter) {
    options.outputReport.formatter = getFormatter(CLIEngine, options.outputReport.formatter);
  }

  return options;
}

function getFormatter(CLIEngine, formatter) {
  if (typeof formatter === 'function') {
    return formatter;
  } // Try to get oficial formatter


  if (typeof formatter === 'string') {
    try {
      return CLIEngine.getFormatter(formatter);
    } catch (e) {// ignored
    }
  }

  return CLIEngine.getFormatter('stylish');
}